/*************************************************************
            SIMPLE HTTP CLIENT ON REXX
      autor: Dmitry Maximovich <maxim@pabl.ru>

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
**************************************************************/

PARSE VALUE ARG(1) WITH A1 A2

IF A1 = '' THEN
   DO
     SAY 'USAGE: wwwget hostname[/path] [port]'
     EXIT
   END
ELSE
   DO
     PARSE VALUE A1 WITH B1'/'B2
     sServer = B1
     IF B2 = '' THEN
        DO
           sRequest = 'GET / HTTP/1.1'||"0D0A"x||'HOST:'B1||"0D0A0D0A"x
           SAY 'Requesting /'
        END
     ELSE
        DO
           sRequest = 'GET /'||B2||' HTTP/1.1'||"0D0A"x||'HOST:'B1||"0D0A0D0A"x
           SAY 'Requesting /'||B2
        END
   END

IF A2 <> '' THEN
  DO
    nPortNumber = A2
  END
ELSE
  DO
    nPortNumber = 80
  END

/* Load REXX Socket library if not already loaded       */
IF RxFuncQuery("SockLoadFuncs") THEN
 DO
   rc = RxFuncAdd("SockLoadFuncs","rxSock","SockLoadFuncs")
   rc = SockLoadFuncs()
 END

IF RxFuncQuery("SysLoadFuncs") THEN
 DO
   rc = RxFuncAdd( "SysLoadFuncs","RexxUtil","SysLoadFuncs")
   rc = SysLoadFuncs()
 END


rc=SockGetHostByName(sServer,"host.")

IF rc <> 1 THEN
   DO
     SAY 'CANNOT RESOLVE HOSTNAME TO ADDRESS: 'sServer
     EXIT -1
   END

SAY 'Trying server:'host.name', address:'host.addr', port:'nPortNumber


socket = SockSocket('AF_INET','SOCK_STREAM',0)
IF socket < 0 THEN
   DO
     SAY 'UNABLE TO CREATE A SOCKET'
     EXIT -1
   END

address.family = 'AF_INET'
address.port = nPortNumber
address.addr = host.addr

rc = SockConnect(socket,'address.')
IF rc < 0 THEN
   DO
     SAY 'UNABLE TO CONNECT TO SERVER:'address.addr
     SIGNAL DO
   END


rc = SockSend(socket, sRequest)

SAY 'REQUEST:***************************************************'

Resp = ''
DO FOREVER
   rc = SockRecv(socket,"sReceive",256)
   IF rc <= 0 THEN
     LEAVE
   Resp = Resp || sReceive
END

SAY ''

/* CR -> CRLF */
nStart = 1
nStop = pos(X2C("0A"), Resp)
do while nStop > 0
  SAY SUBSTR(Resp,nStart,nStop-nStart)
  nStart = nStop + 1
  nStop = pos(X2C("0A"), Resp, nStart)
end


DO:
rc = SockShutDown(socket,2)
rc = SockClose(socket)

